



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SMTP发送邮件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SMTP发送邮件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-13 07:25:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>SMTP是发送邮件的协议，Python内置对SMTP的支持，可以发送纯文本邮件、HTML邮件以及带附件的邮件。</p>
<p>Python对SMTP支持有<code>smtplib</code>和<code>email</code>两个模块，<code>email</code>负责构造邮件，<code>smtplib</code>负责发送邮件。</p>
<p>首先，我们来构造一个最简单的纯文本邮件：</p>
<pre class="prettyprint linenums"><code>from email.mime.text import MIMEText<br />
msg = MIMEText('hello, send by Python...', 'plain', 'utf-8')<br />
</code></pre>
<p>注意到构造<code>MIMEText</code>对象时，第一个参数就是邮件正文，第二个参数是MIME的subtype，传入<code>'plain'</code>，最终的MIME就是<code>'text/plain'</code>，最后一定要用<code>utf-8</code>编码保证多语言兼容性。</p>
<p>然后，通过SMTP发出去：</p>
<pre class="prettyprint linenums"><code># 输入Email地址和口令:<br />
from_addr = raw_input('From: ')<br />
password = raw_input('Password: ')<br />
# 输入SMTP服务器地址:<br />
smtp_server = raw_input('SMTP server: ')<br />
# 输入收件人地址:<br />
to_addr = raw_input('To: ')

import smtplib<br />
server = smtplib.SMTP(smtp_server, 25) # SMTP协议默认端口是25<br />
server.set_debuglevel(1)<br />
server.login(from_addr, password)<br />
server.sendmail(from_addr, [to_addr], msg.as_string())<br />
server.quit()<br />
</code></pre>
<p>我们用<code>set_debuglevel(1)</code>就可以打印出和SMTP服务器交互的所有信息。SMTP协议就是简单的文本命令和响应。<code>login()</code>方法用来登录SMTP服务器，<code>sendmail()</code>方法就是发邮件，由于可以一次发给多个人，所以传入一个<code>list</code>，邮件正文是一个<code>str</code>，<code>as_string()</code>把<code>MIMEText</code>对象变成<code>str</code>。</p>
<p>如果一切顺利，就可以在收件人信箱中收到我们刚发送的Email：</p>
<p><img referrerpolicy="no-referrer"src="https://cdn.liaoxuefeng.com/cdn/files/attachments/0014079993639301a4130bf23574d3586f91928c4f6d6e3000" data-src="https://cdn.liaoxuefeng.com/cdn/files/attachments/0014079993639301a4130bf23574d3586f91928c4f6d6e3000" /></p>
<p>仔细观察，发现如下问题：</p>
<ol><li>邮件没有主题；</li>
<li>收件人的名字没有显示为友好的名字，比如<code>Mr Green &lt;green@example.com&gt;</code>；</li>
<li>明明收到了邮件，却提示不在收件人中。</li></ol>
<p>这是因为邮件主题、如何显示发件人、收件人等信息并不是通过SMTP协议发给MTA，而是包含在发给MTA的文本中的，所以，我们必须把<code>From</code>、<code>To</code>和<code>Subject</code>添加到<code>MIMEText</code>中，才是一封完整的邮件：</p>
<pre class="prettyprint linenums"><code># -*- coding: utf-8 -*-

from email import encoders<br />
from email.header import Header<br />
from email.mime.text import MIMEText<br />
from email.utils import parseaddr, formataddr<br />
import smtplib

def _format_addr(s):<br />
    name, addr = parseaddr(s)<br />
    return formataddr(( \<br />
        Header(name, 'utf-8').encode(), \<br />
        addr.encode('utf-8') if isinstance(addr, unicode) else addr))

from_addr = raw_input('From: ')<br />
password = raw_input('Password: ')<br />
to_addr = raw_input('To: ')<br />
smtp_server = raw_input('SMTP server: ')

msg = MIMEText('hello, send by Python...', 'plain', 'utf-8')<br />
msg['From'] = _format_addr(u'Python爱好者 &lt;%s&gt;' % from_addr)<br />
msg['To'] = _format_addr(u'管理员 &lt;%s&gt;' % to_addr)<br />
msg['Subject'] = Header(u'来自SMTP的问候&hellip;&hellip;', 'utf-8').encode()

server = smtplib.SMTP(smtp_server, 25)<br />
server.set_debuglevel(1)<br />
server.login(from_addr, password)<br />
server.sendmail(from_addr, [to_addr], msg.as_string())<br />
server.quit()<br />
</code></pre>
<p>我们编写了一个函数<code>_format_addr()</code>来格式化一个邮件地址。注意不能简单地传入<code>name &lt;addr@example.com&gt;</code>，因为如果包含中文，需要通过<code>Header</code>对象进行编码。</p>
<p><code>msg['To']</code>接收的是字符串而不是list，如果有多个邮件地址，用<code>,</code>分隔即可。</p>
<p>再发送一遍邮件，就可以在收件人邮箱中看到正确的标题、发件人和收件人：</p>
<p><img referrerpolicy="no-referrer"src="https://cdn.liaoxuefeng.com/cdn/files/attachments/00140800242227674f8f0eed1a64b9e95f2ab9752755e23000" data-src="https://cdn.liaoxuefeng.com/cdn/files/attachments/00140800242227674f8f0eed1a64b9e95f2ab9752755e23000" /></p>
<p>你看到的收件人的名字很可能不是我们传入的<code>管理员</code>，因为很多邮件服务商在显示邮件时，会把收件人名字自动替换为用户注册的名字，但是其他收件人名字的显示不受影响。</p>
<p>如果我们查看Email的原始内容，可以看到如下经过编码的邮件头：</p>
<pre class="prettyprint linenums"><code>From: =?utf-8?b?UHl0aG9u54ix5aW96ICF?= &lt;xxxxxx@163.com&gt;<br />
To: =?utf-8?b?566h55CG5ZGY?= &lt;xxxxxx@qq.com&gt;<br />
Subject: =?utf-8?b?5p2l6IeqU01UUOeahOmXruWAmeKApuKApg==?=<br />
</code></pre>
<p>这就是经过<code>Header</code>对象编码的文本，包含utf-8编码信息和Base64编码的文本。如果我们自己来手动构造这样的编码文本，显然比较复杂。</p>
<h3>发送HTML邮件</h3>
<p>如果我们要发送HTML邮件，而不是普通的纯文本文件怎么办？方法很简单，在构造<code>MIMEText</code>对象时，把HTML字符串传进去，再把第二个参数由<code>plain</code>变为<code>html</code>就可以了：</p>
<pre class="prettyprint linenums"><code>msg = MIMEText('&lt;html&gt;&lt;body&gt;&lt;h1&gt;Hello&lt;/h1&gt;' +<br />
    '&lt;p&gt;send by &lt;a href="http://www.python.org"&gt;Python&lt;/a&gt;...&lt;/p&gt;' +<br />
    '&lt;/body&gt;&lt;/html&gt;', 'html', 'utf-8')<br />
</code></pre>
<p>再发送一遍邮件，你将看到以HTML显示的邮件：</p>
<p><img referrerpolicy="no-referrer"src="https://cdn.liaoxuefeng.com/cdn/files/attachments/001408003582561ea3bdf0296fe49e29a7c20f52ded48a1000" data-src="https://cdn.liaoxuefeng.com/cdn/files/attachments/001408003582561ea3bdf0296fe49e29a7c20f52ded48a1000" /></p>
<h3>发送附件</h3>
<p>如果Email中要加上附件怎么办？带附件的邮件可以看做包含若干部分的邮件：文本和各个附件本身，所以，可以构造一个<code>MIMEMultipart</code>对象代表邮件本身，然后往里面加上一个<code>MIMEText</code>作为邮件正文，再继续往里面加上表示附件的<code>MIMEBase</code>对象即可：</p>
<pre class="prettyprint linenums"><code># 邮件对象:<br />
msg = MIMEMultipart()<br />
msg['From'] = _format_addr(u'Python爱好者 &lt;%s&gt;' % from_addr)<br />
msg['To'] = _format_addr(u'管理员 &lt;%s&gt;' % to_addr)<br />
msg['Subject'] = Header(u'来自SMTP的问候&hellip;&hellip;', 'utf-8').encode()

# 邮件正文是MIMEText:<br />
msg.attach(MIMEText('send with file...', 'plain', 'utf-8'))

# 添加附件就是加上一个MIMEBase，从本地读取一个图片:<br />
with open('/Users/michael/Downloads/test.png', 'rb') as f:<br />
    # 设置附件的MIME和文件名，这里是png类型:<br />
    mime = MIMEBase('image', 'png', filename='test.png')<br />
    # 加上必要的头信息:<br />
    mime.add_header('Content-Disposition', 'attachment', filename='test.png')<br />
    mime.add_header('Content-ID', '&lt;0&gt;')<br />
    mime.add_header('X-Attachment-Id', '0')<br />
    # 把附件的内容读进来:<br />
    mime.set_payload(f.read())<br />
    # 用Base64编码:<br />
    encoders.encode_base64(mime)<br />
    # 添加到MIMEMultipart:<br />
    msg.attach(mime)<br />
</code></pre>
<p>然后，按正常发送流程把<code>msg</code>（注意类型已变为<code>MIMEMultipart</code>）发送出去，就可以收到如下带附件的邮件：</p>
<p><img referrerpolicy="no-referrer"src="https://cdn.liaoxuefeng.com/cdn/files/attachments/0014080077329276557d648f58540f48d04e58520504665000" data-src="https://cdn.liaoxuefeng.com/cdn/files/attachments/0014080077329276557d648f58540f48d04e58520504665000" /></p>
<h3>发送图片</h3>
<p>如果要把一个图片嵌入到邮件正文中怎么做？直接在HTML邮件中链接图片地址行不行？答案是，大部分邮件服务商都会自动屏蔽带有外链的图片，因为不知道这些链接是否指向恶意网站。</p>
<p>要把图片嵌入到邮件正文中，我们只需按照发送附件的方式，先把邮件作为附件添加进去，然后，在HTML中通过引用<code>src="cid:0"</code>就可以把附件作为图片嵌入了。如果有多个图片，给它们依次编号，然后引用不同的<code>cid:x</code>即可。</p>
<p>把上面代码加入<code>MIMEMultipart</code>的<code>MIMEText</code>从<code>plain</code>改为<code>html</code>，然后在适当的位置引用图片：</p>
<pre class="prettyprint linenums"><code>msg.attach(MIMEText('&lt;html&gt;&lt;body&gt;&lt;h1&gt;Hello&lt;/h1&gt;' +<br />
    '&lt;p&gt;&lt;img src="cid:0"&gt;&lt;/p&gt;' +<br />
    '&lt;/body&gt;&lt;/html&gt;', 'html', 'utf-8'))<br />
</code></pre>
<p>再次发送，就可以看到图片直接嵌入到邮件正文的效果：</p>
<p><img referrerpolicy="no-referrer"src="https://cdn.liaoxuefeng.com/cdn/files/attachments/001408019030110a0be121000cc46139f7a72982b19daf3000" data-src="https://cdn.liaoxuefeng.com/cdn/files/attachments/001408019030110a0be121000cc46139f7a72982b19daf3000" /></p>
<h3>同时支持HTML和Plain格式</h3>
<p>如果我们发送HTML邮件，收件人通过浏览器或者Outlook之类的软件是可以正常浏览邮件内容的，但是，如果收件人使用的设备太古老，查看不了HTML邮件怎么办？</p>
<p>办法是在发送HTML的同时再附加一个纯文本，如果收件人无法查看HTML格式的邮件，就可以自动降级查看纯文本邮件。</p>
<p>利用<code>MIMEMultipart</code>就可以组合一个HTML和Plain，要注意指定subtype是<code>alternative</code>：</p>
<pre class="prettyprint linenums"><code>msg = MIMEMultipart('alternative')<br />
msg['From'] = ...<br />
msg['To'] = ...<br />
msg['Subject'] = ...

msg.attach(MIMEText('hello', 'plain', 'utf-8'))<br />
msg.attach(MIMEText('&lt;html&gt;&lt;body&gt;&lt;h1&gt;Hello&lt;/h1&gt;&lt;/body&gt;&lt;/html&gt;', 'html', 'utf-8'))<br />
# 正常发送msg对象...<br />
</code></pre>
<h3>加密SMTP</h3>
<p>使用标准的25端口连接SMTP服务器时，使用的是明文传输，发送邮件的整个过程可能会被窃听。要更安全地发送邮件，可以加密SMTP会话，实际上就是先创建SSL安全连接，然后再使用SMTP协议发送邮件。</p>
<p>某些邮件服务商，例如Gmail，提供的SMTP服务必须要加密传输。我们来看看如何通过Gmail提供的安全SMTP发送邮件。</p>
<p>必须知道，Gmail的SMTP端口是587，因此，修改代码如下：</p>
<pre class="prettyprint linenums"><code>smtp_server = 'smtp.gmail.com'<br />
smtp_port = 587<br />
server = smtplib.SMTP(smtp_server, smtp_port)<br />
server.starttls()<br />
# 剩下的代码和前面的一模一样:<br />
server.set_debuglevel(1)<br />
...<br />
</code></pre>
<p>只需要在创建<code>SMTP</code>对象后，立刻调用<code>starttls()</code>方法，就创建了安全连接。后面的代码和前面的发送邮件代码完全一样。</p>
<p>如果因为网络问题无法连接Gmail的SMTP服务器，请相信我们的代码是没有问题的，你需要对你的网络设置做必要的调整。</p>
<h3>小结</h3>
<p>使用Python的smtplib发送邮件十分简单，只要掌握了各种邮件类型的构造方法，正确设置好邮件头，就可以顺利发出。</p>
<p>构造一个邮件对象就是一个<code>Messag</code>对象，如果构造一个<code>MIMEText</code>对象，就表示一个文本邮件对象，如果构造一个<code>MIMEImage</code>对象，就表示一个作为附件的图片，要把多个对象组合起来，就用<code>MIMEMultipart</code>对象，而<code>MIMEBase</code>可以表示任何对象。它们的继承关系如下：</p>
<pre class="prettyprint linenums"><code>Message<br />
+- MIMEBase<br />
   +- MIMEMultipart<br />
   +- MIMENonMultipart<br />
      +- MIMEMessage<br />
      +- MIMEText<br />
      +- MIMEImage<br />
</code></pre>
<p>这种嵌套关系就可以构造出任意复杂的邮件。你可以通过<a href="https://docs.python.org/2/library/email.mime.html" rel="external nofollow noreferrer">email.mime文档</a>查看它们所在的包以及详细的用法。</p>
<p>源码参考：</p>
<p><a href="https://github.com/michaelliao/learn-python/tree/master/email" rel="external nofollow noreferrer">https://github.com/michaelliao/learn-python/tree/master/email</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g07y7q.html">ACM&sol;ICPC 之 Floyd练习六道&lpar;ZOJ2027-POJ2253-POJ2472-POJ1125-POJ1603-POJ2607&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld3je9.html">MongoDB 入门之安装篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvmd3xq.html">ARM汇编程序基本知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr1jxq.html">Android新浪微博获取评论信息、发表评论、转发微博等</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13z468.html">微软今日发布汇总：VS2015&comma; &period;NET 4&period;6&comma; C&num; 6&period;0&comma; F&num; 4&period;0等重量级产品正式上线</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlkl69.html">49&period; Group Anagrams</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdw0xq.html">WebStorm 对 Mocha 完美支持。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn0j6oq.html">学习下关于ViewStub实例的用法及带Drawable的TextView的妙用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgze3d8.html">leetcode 编辑距离</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmeyw8.html">js原生设计模式&mdash;&mdash;2面向对象编程之闭包1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gedjvl8.html">XHTML清单</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd37m49.html">Spring&mdash;&mdash;Web应用中的IoC容器创建&lpar;WebApplicationContext根应用上下文的创建过程&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2wxx9.html">201521123099 《Java程序设计》第13周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zolvzvq.html">JavaScript面向对象编程（9）高速构建继承关系之整合原型链</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpdvl79.html">python中的subprocess&period;Popen（）使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxde1vj9.html">Linux下的Sreen命令使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j2yd5q.html">asp 读cookie 下划线 丢失</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2oyex9.html">mysql更新字段值提示You are using safe update mode and you tried to update a table without a WHERE that uses a KEY column To disable safe mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl5n0k9.html">Java中字符转int</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jr3e8.html">Garlands CodeForces - 707E &lpar;离线树状数组&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2mjny9.html">tft屏图像文字一起显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r6y728.html">Shell for while 循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5rwgrq.html">nfs共享文件搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oyvlj8.html">VMware14安装centos7</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25l1xwq.html">plsql developer 10注册码----亲测截止2017年5月6可用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r6xj08.html">python之字符编码（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2mwkz9.html">微信小程序细节</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2mm219.html">两步完成ssh免密码登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m277woq.html">ORACLE 12c 配置PL&sol;SQL 并登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/960wwr39.html">Windows Media Player添加播放插件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
